#!/usr/bin/env python

#Configurace zprav a zarizeni
metadata = {
    'deviceID': '46b877a1-1639-4e79-b86d-1eb8a5e92421',
    'modelID': 1,
    'baudRate': 115200,
    'timeSleep': 5,
    'serailPort': '/dev/ttyACM0',
    'msgTypePhoto': 'c6cf6810e0f18cbd9536',
    'msgTypeTelemetry': '408eb93c73c389b430cb',
    'deviceToken': 'e52f9c4dce05355799246f915da50',  #HEXA TOKEN
    'url' : '/com.sap.iotservices.mms/v1/api/http/data/',
    'host': 'iotmmss0015766703trial.hanatrial.ondemand.com'
}


import datetime

"""Get data script"""
class Config (object):
    __VERSION__ = "0.0.1"
    __AUTHOR__ = "Filip Maly XMALF002"
    __FACULTY_ = "PEF CZU INFONK"



# OBSLUZNE METODY PRO ODESILANI A PRIJIMANI ZPRAV

    def getDeviceId(self):
        id = metadata['deviceID']
        return id

    def getSerialPort(self):
        return metadata['serailPort']

    def getBaudRate(self):
        return metadata['baudRate']

    def getFromMetadata(self , atribute):
        return metadata[atribute]

    def getBodyPhoto(self):
        bodyPhoto = {
            'mode': 'sync',
            'messageType': self.getFromMetadata('msgTypePhoto'),
            'messages':[{
                'timestamp': datetime.datetime.now().isoformat(),
                'photoBase64': "",
                'deviceID': self.getFromMetadata('modelID'),
            }]
                }
        return bodyPhoto

    def getDeviceUrl(self):
        url =  self.getFromMetadata('url') + self.getFromMetadata('deviceID')
        return url

    def getHost(self):
        host = self.getFromMetadata('host')
        return host

    def getTelemetryBody(self):
        body = {
            'mode': 'sync',
            'messageType': self.getFromMetadata('msgTypeTelemetry'),
            'messages': [{
                'log': datetime.datetime.now().isoformat(),
                'deviceID': self.getFromMetadata('modelID'),
                'roll': '0',
                'pitch': '0',
                'throttle': '0',
                'yaw': '0',
                'aux1': '0',
                'aux2': '0',
                'aux3': '0',
                'aux4': '0',
                'fix': 'false',
                'numsat': '0',
                'longitude': '0',
                'latitude': '0',
                'speed': '0',
                'altitude': '0',
                'distanceHome': '0',
                'headingHome': '0',
                'amperage': '0',
                'rssi': '0',
                'vbat': '0',
                'powermetersum': '0',
                'motor1': '0',
                'motor2': '0',
                'motor3': '0',
                'motor4': '0',
                'motor5': '0',
                'motor6': '0',
                'motor7': '0',
                'motor8': '0',
                'version': '0',
                'type': '0',
                'angx': '0',
                'angy': '0',
                'heading': '0',
            }]
        }
        return body

    def getRequestHeader(self):
        requestHeader = {
            'Authorization': 'Bearer '+ self.getFromMetadata('deviceToken'),
            'Content-Type' : 'application/json;charset=utf-8'
            }
        return requestHeader

    def getPhotoHeader(self):
        photoHeader = {
           'Authorization': 'Bearer '+  self.getFromMetadata('deviceToken'),
            'Content-Type' : 'application/json;charset=utf-8'
        }
        return photoHeader

    def getTelemetryHeader(self):
        telemetryHeader = {
            'Authorization': 'Bearer '+ self.getFromMetadata('deviceToken'),
            'Content-Type' : 'application/json;charset=utf-8'
        }
        return  telemetryHeader


