/**
@param {connection} Connection - The SQL connection used in the OData request
@param {beforeTableName} String - The name of a temporary table with the single entry before the operation (UPDATE and DELETE events only)
@param {afterTableName} String -The name of a temporary table with the single entry after the operation (CREATE and UPDATE events only)
 */

$.import("droneiot.util", "session");
var SESSIONINFO = $.droneiot.util.session;

function createDroneData(param) {
	$.trace.error("ERROR:: " + param);
	var after = param.afterTableName;
	//Get Input New Record Values
	var pStmt = param.connection.prepareStatement("select * from \"" + after + "\"");
	var Data = SESSIONINFO.recordSetToJSON(pStmt.executeQuery(), "Details");
	pStmt.close();

	var DRONID = Data.Details[0].DRONID;
	var OWNER = Data.Details[0].OWNER.toString();
	var DRONENAME = Data.Details[0].DRONENAME.toString();
	var COUNTFLY = Data.Details[0].COUNTFLY.toString();
	var COUNTFLYFAR = Data.Details[0].COUNTFLYFAR.toString();
	var FRAME = Data.Details[0].FRAME.toString();
	var LASTFLYFAR = Data.Details[0].LASTFLYFAR.toString();
	var LASTFLYTIME = Data.Details[0].LASTFLYTIME.toString();
	var LASTUSE = Data.Details[0].LASTUSE.toString();
	var IOTDEVICE = Data.Details[0].IOTDEVICE.toString();
	var connection = $.hdb.getConnection();

	connection.executeUpdate(
		'INSERT INTO "DRONMASTER"."DRONLIST" (OWNER,FRAME,DRONENAME,COUNTFLY,COUNTFLYFAR,LASTFLYFAR,LASTFLYTIME,LASTUSE,DRONID,IOTDEVICE ) VALUES (?,?,?,?,?,?,?,?,?,?)',
		OWNER, FRAME, DRONENAME,
		COUNTFLY, COUNTFLYFAR, LASTFLYFAR, LASTFLYTIME, LASTUSE, DRONID, IOTDEVICE);

	connection.commit();
	$.trace.debug("Entered create test function...");

}

function createNewRequest(param) {
	$.trace.error("ERROR:: " + param);
	var after = param.afterTableName;
	//Get Input New Record Values
	var pStmt = param.connection.prepareStatement("select * from \"" + after + "\"");
	var Data = SESSIONINFO.recordSetToJSON(pStmt.executeQuery(), "Details");
	pStmt.close();

	var G_DEVICE = Data.Details[0].G_DEVICE;
	var ALARM = Data.Details[0].ALARM;
	var FOTO = Data.Details[0].FOTO;
	var LED = Data.Details[0].LED;
	var GPS_HOLD = Data.Details[0].GPS_HOLD;
	var GPS_HOME = Data.Details[0].GPS_HOME;
	var CREATE =  new Date(Data.Details[0].CREATE);
	var STATE = Data.Details[0].STATE;
	var connection = $.hdb.getConnection();

	connection.executeUpdate(
		'INSERT INTO "DRONMASTER"."DRONCOMMAND" (G_DEVICE,ALARM,FOTO,LED,GPS_HOLD,GPS_HOME,CREATE,STATE ) VALUES (?,?,?,?,?,?,?, ?)', G_DEVICE, ALARM,
		FOTO, LED, GPS_HOLD, GPS_HOME, CREATE, STATE);

	connection.commit();

}