/**
@param {connection} Connection - The SQL connection used in the OData request
@param {beforeTableName} String - The name of a temporary table with the single entry before the operation (UPDATE and DELETE events only)
@param {afterTableName} String -The name of a temporary table with the single entry after the operation (CREATE and UPDATE events only)
 */

$.import("droneiot.util", "session");
var SESSIONINFO = $.droneiot.util.session;

function deleteLogData(param) {
	$.trace.error("ERROR:: " + param);
	var after = param.beforeTableName;
	//Get Input New Record Values
	var pStmt = param.connection.prepareStatement("select * from \"" + after + "\"");
	var Data = SESSIONINFO.recordSetToJSON(pStmt.executeQuery(), "Details");
	pStmt.close();

	var deviceID = Data.Details[0].G_DEVICE;
		var created = new Date(Data.Details[0].G_CREATED);
    $.trace.error("ERROR:: " + created.toString() +deviceID );
	var connection = $.hdb.getConnection();
	connection.executeUpdate('DELETE FROM "DRONMASTER"."T_IOT_408EB93C73C389B430CB" WHERE G_CREATED = ? AND G_DEVICE = ?', created , deviceID);
	connection.commit();
	$.trace.debug("Entered create test function...");
}

function deleteDroneList(param) {
	$.trace.error("ERROR:: " + param);
	var after = param.beforeTableName;
	//Get Input New Record Values
	var pStmt = param.connection.prepareStatement("select * from \"" + after + "\"");
	var Data = SESSIONINFO.recordSetToJSON(pStmt.executeQuery(), "Details");
	pStmt.close();
	var id = Data.Details[0].DRONID;
	var connection = $.hdb.getConnection();
	connection.executeUpdate('DELETE FROM "DRONMASTER"."DRONLIST" WHERE DRONID = ?', id);
	connection.commit();
	$.trace.debug("Entered create test function...");
}


function deletePhotoData(param) {
	$.trace.error("ERROR:: " + param);
	var after = param.beforeTableName;
	//Get Input New Record Values
	var pStmt = param.connection.prepareStatement("select * from \"" + after + "\"");
	var Data = SESSIONINFO.recordSetToJSON(pStmt.executeQuery(), "Details");
	pStmt.close();
	var id = Data.Details[0].G_CREATED;
	var deviceID = Data.Details[0].G_DEVICE;
	var connection = $.hdb.getConnection();
	connection.executeUpdate('DELETE FROM "DRONMASTER"."T_IOT_BB68C2DC4F0D33C616BC" WHERE G_CREATED = ? AND G_DEVICE = ?', id, deviceID);
	connection.commit();
	$.trace.debug("Entered create test function...");
}


function deleteDronCommand(param) {
	$.trace.error("ERROR:: " + param);
	var after = param.beforeTableName;
	//Get Input New Record Values
	var pStmt = param.connection.prepareStatement("select * from \"" + after + "\"");
	var Data = SESSIONINFO.recordSetToJSON(pStmt.executeQuery(), "Details");
	pStmt.close();
	var id = Data.Details[0].COMMANDID;
	var connection = $.hdb.getConnection();
	connection.executeUpdate('DELETE FROM "DRONMASTER"."DRONCOMMAND" WHERE COMMANDID = ?', id);
	connection.commit();
	$.trace.debug("Entered create test function...");
}