sap.ui.define([
	"DRONEDRONE_IOT/controller/BaseController",
	"sap/ui/core/mvc/Controller",
	"DRONEDRONE_IOT/controller/iot"
], function(BaseController, Controller, IOT) {
	"use strict";

	var markers = [];

	return BaseController.extend("DRONEDRONE_IOT.controller.master", {

		onInit: function() {
			//for console
			window.master = this.getView();
			window.masterController = this;
			window.iot = this.createIOTapi();
			this.iot = new IOT();

			// map object je globální je na něm google mapa

			//MOCK DATA
			//this.mockData();

			this.setModels();

		},

		/*  		   	function initWpMap() 	{
				var mapProp= {
				    center:new google.maps.LatLng(51.508742,-0.120850),
				    zoom:5,
				};
				var map=new google.maps.Map(document.getElementById("mapMission"),mapProp);
				}*/

		onAfterRendering: function() {

		},

		onPresIconTab: function(oEvent) {
			this.getModel("mainModel").setProperty("/btnFootMap", false);
			switch (oEvent.getSource().getSelectedKey()) {
				case "mission":
					this.initMission();
					break;
				case "database":
					this.getModel("mainModel").setProperty("/btnFootMap", true);
					break;
				default:
			}
		},

		setModels: function() {
			var oDataModel = new sap.ui.model.json.JSONModel({});
			var oDataModel2 = new sap.ui.model.json.JSONModel();
			var oDataModel3 = new sap.ui.model.json.JSONModel();
			var oDataModel4 = new sap.ui.model.json.JSONModel();
			var oDataModel5 = new sap.ui.model.json.JSONModel();
			var oDataModel6 = new sap.ui.model.json.JSONModel();
			var oDataModel7 = new sap.ui.model.json.JSONModel();

			this.setModel(oDataModel, "mainModel");
			this.setModel(oDataModel2, "controlModel");
			this.setModel(oDataModel3, "monitoringModel");
			this.setModel(oDataModel4, "dataModel");
			this.setModel(oDataModel5, "tableLogModel");
			this.setModel(oDataModel6, "photoModel");
			this.setModel(oDataModel7, "configModel");

			this.getModel("mainModel").setSizeLimit(10000);
			this.getModel("controlModel").setSizeLimit(10000);
			this.getModel("monitoringModel").setSizeLimit(10000);
			this.getModel("dataModel").setSizeLimit(10000);
			this.getModel("tableLogModel").setSizeLimit(10000);
			this.getModel("photoModel").setSizeLimit(10000);

			this.getModel("mainModel").setProperty("/masterSelecttedItem", 5);
			this.getModel("mainModel").setProperty("/timerTime", 5);
			this.getModel("mainModel").setProperty("/timerTimeCount", 5);
			this.getModel("mainModel").setProperty("/timeRefresh", this.getResourceBundle().getText("masterRefreshTime", [this.getModel(
				"mainModel").getProperty("/timerTimeCount")]));
			this.getModel("mainModel").setProperty("/enableEdit", false);
			this.getModel("mainModel").setProperty("/selectedDrone", this.getResourceBundle().getText("noExist"));
			this.getModel("mainModel").setProperty("/visibleInfoLog", false);
			this.getModel("mainModel").setProperty("/infoLogCount", 0);
			this.getModel("mainModel").setProperty("/isRefreshOn", false);
			this.getModel("mainModel").setProperty("/reqValue", 0);
			this.getModel("mainModel").setProperty("/btnFootMap", false);
			this.getModel("mainModel").setProperty("/visibleErrBtn", false);
			this.getModel("mainModel").setProperty("/countErrBtn", 0);
			this.getModel("mainModel").setProperty("/errLogs", []);

			this.getModel("mainModel").setProperty("/vizFrameSet", [{
				"Dimension": this.getResourceBundle().getText("succes"),
				"Measures": 0

			}, {
				"Dimension": this.getResourceBundle().getText("error"),
				"Measures": 0

			}]);

			this.getModel("configModel").setProperty("/msgType", "1a6fa20042f203191551");

			this.getModel("mainModel").setProperty("/reqState", {
				ALARM: false,
				FOTO: false,
				LED: false,
				GPS_HOLD: false,
				GPS_HOME: false
			});

			this.getModel("mainModel").setProperty("/addModel", {});

			this.initMaster();
		},

		initMission: function() {
			var mapProp = {
				center: {
					lat: 50.137596,
					lng: 14.5151436
				},
				zoom: 8
			};

			this.WpMap = new google.maps.Map(document.getElementById("WpMap"), mapProp);

			this.WpMap.addListener('click', function(event) {
				this.addMarker(event.latLng);
			}.bind(this));

		},

		addMarker: function(location) {
			var marker = new google.maps.Marker({
				position: location,
				map: this.WpMap
			});
			markers.push(marker);
		},

		setWpPoints: function() {
			var WpMap = this.WpMap;
			console.log(WpMap);

			var flightPlanCoordinates = [{
				lat: 50.137596,
				lng: 14.515143
			}, {
				lat: 50.137580,
				lng: 14.515143
			}, {
				lat: 50.137570,
				lng: 14.515143
			}, {
				lat: 50.137550,
				lng: 14.515143
			}];

			var pos = {
				lat: 50.137596,
				lng: 14.5151436
			};

			WpMap.setCenter(pos);

			//TO DO: udělat 2 pohledy jeden čtverec a druhy naklikat sám

			var flightPath = new google.maps.Polyline({
				path: flightPlanCoordinates,
				geodesic: true,
				strokeColor: '#FF0000',
				strokeOpacity: 1.0,
				strokeWeight: 2
			});

			flightPath.setMap(WpMap);
		},

		headerInfoText: function(bBool) {
			self = window.masterController;
			return (bBool ? self.getResourceBundle().getText("dbRefreshOn") : self.getResourceBundle().getText("dbRefreshOff"));
		},

		headerInfoState: function(bBool) {
			return (bBool ? "Error" : "Success");
		},

		headerInfoIcon: function(bBool) {
			return (bBool ? "sap-icon://alert" : "sap-icon://hint");
		},

		onEditMaster: function() {
			this.getModel("mainModel").setProperty("/enableEdit", true);
		},

		onShowMaster: function() {
			this.getModel("mainModel").setProperty("/enableEdit", false);
		},

		getXsjs: function() {
			$.ajax({
				url: "/destinations/iot_xsjs/droneiot/util/test.xsjs",
				success: function(result) {
					console.log(result);
				}
			});

		},

		initMaster: function() {
			this.getOwnerComponent().getModel().read("/Main_Data", {
				success: function(data) {
					if (data.results && data.results.length > 0) {
						this.getModel("mainModel").setProperty("/selectedDrone", data.results[0].DRONENAME);
						sap.ui.getCore().byId("masterSelect").setSelectedKey(data.results[0].DRONID);
						this.bindMasterPage(data.results[0].DRONID);
						this.bindDetailPages(data.results[0].IOTDEVICE);
						this.toMainPage();
					} else {
						this.getView().byId("masterPage").setBusy(false);
						this.toNoDataPage();
					}
				}.bind(this),
				erorr: function(oError) {
					var msg = this.getResourceBundle().getText("readError") + oError;
					sap.m.MessageToast.show(msg, {
						duration: 5000
					});
					this.showError(oError);
				}.bind(this)
			});

		},

		onDeleteFromRequestTable: function(oEvent) {
			var data = oEvent.getSource().getBindingContext().getObject();
			this.deleteFromReqHistory(data);
		},

		onDeleteSeletctedReq: function(oEvent) {
			var oContexts = sap.ui.getCore().byId("req_history").getSelectedContexts();
			oContexts.forEach(function(item) {
				this.deleteFromReqHistory(item.getObject());
			}.bind(this));
		},

		deleteFromReqHistory: function(oData) {
			this.getOwnerComponent().getModel().remove(this.getOwnerComponent().getModel().createKey("/Req_Data", oData), {
				success: function(data) {
					this.bindReqDataHistory();
				}.bind(this),
				error: function(err) {
					this.showError(err);
				}
			});
		},

		bindReqDataHistory: function(sDevice) {
			var device = sap.ui.getCore().byId("masterSelect").getSelectedItem() ? sap.ui.getCore().byId("masterSelect").getSelectedItem().getBindingContext()
				.getProperty("IOTDEVICE") : "";
			var table = sap.ui.getCore().byId("req_history");
			var oBindingInfo = table.getBindingInfo("items");
			var oFilter = [new sap.ui.model.Filter("G_DEVICE", "EQ", sDevice ? sDevice : device)];
			table.bindAggregation("items", {
				path: oBindingInfo.path,
				template: oBindingInfo.template,
				sorter: oBindingInfo.sorter,
				filters: oFilter
			});

			var succes = 0;
			var error = 0;

			this.getOwnerComponent().getModel().read(oBindingInfo.path, {
				filters: oFilter,
				success: function(data) {
					var items = data.results;
					items.forEach(function(item, index) {
						if (index === (items.length - 1)) {
							this.getModel("mainModel").setProperty("/reqState", {
								ALARM: item.ALARM === 1,
								FOTO: item.FOTO === 1,
								LED: item.LED === 1,
								GPS_HOLD: item.GPS_HOLD === 1,
								GPS_HOME: item.GPS_HOME === 1
							});
						}
						if (item.STATE === 1) {
							succes++;
						} else {
							error++;
						}
					}.bind(this));
					this.getModel("mainModel").setProperty("/vizFrameSet", [{
						"Dimension": this.getResourceBundle().getText("succes"),
						"Measures": succes

					}, {
						"Dimension": this.getResourceBundle().getText("error"),
						"Measures": error

					}]);
				}.bind(this),
				error: function(err) {
					this.showError(err);
				}.bind(this)
			});

		},

		setMicroColor: function(value) {
			return value > 51 ? "Good" : "Error";
		},

		onSelectItem: function() {
			var items = sap.ui.getCore().byId("logTable").getSelectedItems();
			this.getModel("mainModel").setProperty("/visibleInfoLog", items.length > 0);
			this.getModel("mainModel").setProperty("/infoLogCount", items.length);

		},

		bindMasterPage: function(nId) {
			this.getView().byId("masterPage").bindElement("/Main_Data(" + nId + ")", {});
			this.getView().byId("masterPage").setBusy(false);
		},

		onMasterDroneChange: function(oEvent) {
			this.bindMasterPage(oEvent.getSource().getSelectedKey());
			this.getModel("mainModel").setProperty("/selectedDrone", oEvent.getSource().getSelectedItem().getText());
			this.bindDetailPages(oEvent.getSource().getSelectedItem().getBindingContext().getProperty("IOTDEVICE"));
			this.getModel("mainModel").setProperty("/enableEdit", false);
		},

		onAddNewModel: function(oEvent) {
			var self = this;
			var dialog = new sap.m.Dialog({
				title: "{i18n>formNewDroneTitle}",
				content: [new sap.ui.xmlfragment("DRONEDRONE_IOT.fragment.addModelForm", self)],
				beginButton: new sap.m.Button({
					text: '{i18n>dialog.ok}',
					enabled: true,
					press: function() {
						if (this.checkFormInputs) {
							this.saveAddForm();
							dialog.close();
						}
					}.bind(this)
				}),
				endButton: new sap.m.Button({
					text: '{i18n>dialog.close}',
					press: function() {
						dialog.close();
					}.bind(this)
				})
			});

			//to get access to the global model
			this.getView().addDependent(dialog);

			dialog.open();

		},

		onMasterPageUpdateDrone: function(oEvent) {
			var oContext = oEvent.getSource().getBindingContext();
			var obj = oContext.getObject();
			obj.OWNER = sap.ui.getCore().byId("masterOwner").getValue();
			obj.LASTUSE = sap.ui.getCore().byId("masterLastUse").getValue();
			obj.LASTFLYTIME = sap.ui.getCore().byId("masterlastFlyTime").getValue();
			obj.LASTFLYFAR = sap.ui.getCore().byId("masterLastKmCount").getValue();
			obj.FRAME = sap.ui.getCore().byId("masterFrame").getValue();
			obj.DRONENAME = sap.ui.getCore().byId("masterDroneName").getValue();
			obj.COUNTFLY = sap.ui.getCore().byId("masterkmCount").getValue();
			obj.COUNTFLYFAR = sap.ui.getCore().byId("masterCountFly").getValue();
			this.getOwnerComponent().getModel().update(oContext.getPath(), obj, {
				success: function(data, oResponse) {
					this.getView().byId("masterPage").getModel().refresh(true);
					this.onShowMaster();
				}.bind(this),
				error: function(err) {
					this.showError(err);
				}.bind(this)
			});

		},

		bindDetailPages: function(IOTDEVICE) {
			var date = new Date();
			var dateMin = new Date(date.setHours(0, 0, 0, 1));
			var dateMax = new Date(date.setHours(23, 59, 59, 0));
			var oFilter = [new sap.ui.model.Filter("G_DEVICE", "EQ", IOTDEVICE), new sap.ui.model.Filter("G_CREATED", "BT", dateMin, dateMax)];
			this.loadLogTable(oFilter);
			this.loadPhotoData(oFilter);
			this.bindReqDataHistory(IOTDEVICE);

		},

		loadLogTable: function(oFilter) {
			this.getOwnerComponent().getModel().read("/MSP_Data", {
				filters: oFilter,
				success: function(data) {
					this.getModel("tableLogModel").setData(data.results);
					this.onSelectItem();
				}.bind(this),
				erorr: function(err) {
					this.showError(err);
				}
			});
		},

		loadPhotoData: function(oFilter) {
			this.getOwnerComponent().getModel().read("/Photo_Data", {
				filters: oFilter,
				success: function(data) {
					this.getModel("photoModel").setData(data.results);
				}.bind(this),
				erorr: function(err) {
					this.showError(err);
				}.bind(this)
			});
		},

		onPressMasterRefresh: function(oEvent) {
			var self = this;

			function myTimer() {
					var sId = sap.ui.getCore().byId("masterSelect").getSelectedItem().getBindingContext().getProperty("IOTDEVICE");
				self.bindDetailPages(sId);
			}

			function myTimerSecond() {
				var count = self.getModel("mainModel").getProperty("/timerTimeCount", count);
				count = count > 1 ? count - 1 : self.getModel("mainModel").getProperty("/timerTime");
				self.getModel("mainModel").setProperty("/timerTimeCount", count);
				self.getModel("mainModel").setProperty("/timeRefresh", self.getResourceBundle().getText("masterRefreshTime", [count]));
			}

			if (oEvent.getSource().getPressed()) {
				this.myTimer = setInterval(myTimer, Number(self.getModel("mainModel").getProperty("/timerTime")) * 1000);
				this.myTimerSecond = setInterval(myTimerSecond, 1000);
			} else {
				clearInterval(this.myTimer);
				clearInterval(this.myTimerSecond);
			}

		},

		onMasterSelectChange: function(oEvent) {
			this.getModel("mainModel").setProperty("/timerTime", oEvent.getSource().getValue());
			clearInterval(this.myTimer);
			clearInterval(this.myTimerSecond);
			sap.ui.getCore().byId("masterToggleB").setPressed(false);
		},

		/*	formatterGetModelID: function(sLog) {
				var res = sLog.split("/");
				return res[1];
			},*/

		onPressCurrLocation: function() {
			if (navigator.geolocation) {
				navigator.geolocation.getCurrentPosition(function(position) {
					var pos = {
						lat: position.coords.latitude,
						lng: position.coords.longitude
					};

					infoWindow.setPosition(pos);
					infoWindow.setContent(this.getResourceBundle().getText("lcoationFound"));
					infoWindow.open(map);
					map.setCenter(pos);
					map.setZoom(20);
				}.bind(this));
			} else {
				var msg = this.getResourceBundle().getText("locationNotFound");
				sap.m.MessageToast.show(msg, {
					duration: 5000
				});
			}
		},

		onMasterPageDelete: function(oEvent) {
			var oContext = oEvent.getSource().getBindingContext();
			var self = this;
			var dialog = new sap.m.Dialog({
				title: '{i18n>dialogRemMasterTitle}',
				type: 'Message',
				state: 'Warning',
				content: new sap.m.Text({
					text: '{i18n>dialogRemMasterText}'
				}),
				beginButton: new sap.m.Button({
					text: '{i18n>dialogRemMasterYes}',
					press: function() {
						self.onDeleteDroneInfo(oContext);
						dialog.close();
					}
				}),
				endButton: new sap.m.Button({
					text: '{i18n>dialogRemMasterNo}',
					press: function() {
						dialog.close();
					}
				}),
				afterClose: function() {
					dialog.destroy();
				}
			});
			this.getView().addDependent(dialog);
			dialog.open();
		},

		saveAddForm: function(oContext) {
			var oData = this.getModel("mainModel").getProperty("/addModel");
			var data = {
				DRONID: 2,
				OWNER: oData.owner,
				LASTUSE: oData.lastUse,
				LASTFLYTIME: oData.lastFlight,
				LASTFLYFAR: oData.lastFar,
				COUNTFLYFAR: oData.lastLong,
				COUNTFLY: oData.count,
				FRAME: oData.name,
				DRONENAME: oData.owner,
				IOTDEVICE: this.getModel("mainModel").getProperty("/selectedAddFormKey")
			};

			this.getOwnerComponent().getModel().create("/Main_Data", data, {
				success: function(data) {
					this.initMaster();
					//	this.getModel("mainModel").setProperty("/enableEdit", false);
				}.bind(this),
				error: function(err) {
					this.showError(err);
				}.bind(this)
			});

		},

		onDeleteDroneInfo: function(oContext) {
			this.getOwnerComponent().getModel().remove(this.getOwnerComponent().getModel().createKey("/Main_Data", oContext.getObject()), {
				success: function(data) {
					this.initMaster();
					this.getModel("mainModel").setProperty("/enableEdit", false);
				}.bind(this),
				error: function(err) {
					this.showError(err);
				}.bind(this)
			});

		},

		onDeleteTableLogItem: function(element) {
			var sId = sap.ui.getCore().byId("masterSelect").getSelectedItem().getBindingContext().getProperty("IOTDEVICE");
			this.getOwnerComponent().getModel().remove(this.getOwnerComponent().getModel().createKey("/MSP_Data", element.getObject()), {
				success: function(data) {
					jQuery.sap.delayedCall(1500, {}, function() {
						this.bindDetailPages(sId);
					}.bind(this));
				}.bind(this),
				error: function(err) {
					this.showError(err);
				}.bind(this)

			});

		},

		onDeleteTableLogItems: function(tableItems) {
			var self = this;
			var sId = sap.ui.getCore().byId("masterSelect").getSelectedItem().getBindingContext().getProperty("IOTDEVICE");
			var oModel = this.getOwnerComponent().getModel();
			if (tableItems.length > 0) {
				tableItems.forEach(function(element) {
					var oObject = element.getObject();
					if (oObject.hasOwnProperty("C_LOG")) {
						oModel.remove(oModel.createKey("/MSP_Data", oObject), {
							success: function(data) {
								
							},
							error: function(err) {
								this.showError(err);
							}.bind(this)

						});
					}
				});
				self.bindDetailPages(sId);
			}
		},
		onDeleteTableLog: function(oEvent) {
			var tableItems = sap.ui.getCore().byId("logTable").getSelectedContexts("tableLogModel");
			this.onLogTableDelete(null, tableItems);
		},

		onDeleteSingleItem: function(oEvent) {
			var oContext = oEvent.getSource().getBindingContext("tableLogModel");
			this.onLogTableDelete(oContext, null);
		},
		onLogTableDelete: function(oContext, items) {
			var self = this;
			var dialog = new sap.m.Dialog({
				title: '{i18n>dialogRemMasterTitle}',
				type: 'Message',
				state: 'Warning',
				content: new sap.m.Text({
					text: '{i18n>dialogRemMasterText}'
				}),
				beginButton: new sap.m.Button({
					text: '{i18n>dialogRemMasterYes}',
					press: function() {
						if (items) {
							self.onDeleteTableLogItems(items);
						} else {
							self.onDeleteTableLogItem(oContext);
						}
						dialog.close();
					}
				}),
				endButton: new sap.m.Button({
					text: '{i18n>dialogRemMasterNo}',
					press: function() {
						dialog.close();
					}
				}),
				afterClose: function() {
					dialog.destroy();
				}
			});
			this.getView().addDependent(dialog);
			dialog.open();
		},

		onPressMap: function(oEvent) {
			var latitude = sap.ui.getCore().byId("monitoringSelectLatitude").getValue();
			var longitude = sap.ui.getCore().byId("monitoringSelectLongitude").getValue();
			map.setZoom(20);
			map.setCenter(new google.maps.LatLng(latitude, longitude));
		},

		getTableGps: function(oEvent) {
			var oContext = oEvent.getSource().getParent().getBindingContext("tableLogModel");
			var longitude = this.formatteGps(Number(oContext.getProperty("C_LONGITUDE")));
			var latitude = this.formatteGps(Number(oContext.getProperty("C_LATITUDE")));
			sap.ui.getCore().byId("monitoringSelectLatitude").setValue(latitude);
			sap.ui.getCore().byId("monitoringSelectLongitude").setValue(longitude);
			map.setZoom(20);
			map.setCenter(new google.maps.LatLng(latitude, longitude));
			var marker = new google.maps.Marker({
				position: {
					lat: latitude,
					lng: longitude
				},
				map: map
			});
			this.getView().byId("iconTabBar").setSelectedKey("monitoring");
		},

		formatteGps: function(nGps) {
			return Number(nGps) / 10000000;
		},

		tableLogHeader: function(oGroup) {
			return new sap.m.GroupHeaderListItem({
				title: new Date(oGroup.G_CREATED).getDate(),
				upperCase: false
			});
		},

		tableCreateRoute: function(oEvent) {
			var tableItems = sap.ui.getCore().byId("logTable").getSelectedContexts("tableLogModel");
			var self = this;
			var points = [];
			if (tableItems.length > 0) {
				tableItems.forEach(function(element) {
					points.push({
						lat: self.formatteGps(Number(element.getProperty("C_LATITUDE"))),
						lng: self.formatteGps(Number(element.getProperty("C_LONGITUDE")))
					});
				});
				this.makeMapTrack(points);
			}
		},

		makeMapTrack: function(points) {
			var flightPath = new google.maps.Polyline({
				path: points,
				geodesic: true,
				strokeColor: '#FF0000',
				strokeOpacity: 1.0,
				strokeWeight: 2
			});
			flightPath.setMap(null);
			map.setZoom(14);
			map.setCenter(new google.maps.LatLng(points[0].lat, points[0].lng));
			flightPath.setMap(map);

			this.getView().byId("iconTabBar").setSelectedKey("monitoring");
		},

		onDeselectTable: function(oEvent) {
			sap.ui.getCore().byId("logTable").removeSelections();
		},

		onDeletePhoto: function() {
			var IOTDEVICE = sap.ui.getCore().byId("masterSelect").getSelectedItem().getBindingContext().getProperty("IOTDEVICE");
			var oFilter = [new sap.ui.model.Filter("G_DEVICE", "EQ", IOTDEVICE)];
			if (sap.ui.getCore().byId(sap.ui.getCore().byId("photoCarousel").getActivePage())) {
				var oContext = sap.ui.getCore().byId(sap.ui.getCore().byId("photoCarousel").getActivePage()).getBindingContext("photoModel");
				this.getOwnerComponent().getModel().remove(this.getOwnerComponent().getModel().createKey("/Photo_Data", oContext.getObject()), {
					success: function(data) {
						this.loadPhotoData(oFilter);
					}.bind(this),
					error: function(err) {
						this.showError(err);
					}.bind(this)

				});
			}
		},

		onPressReqAll: function(oEvent) {
			//0 je prazdny prikaz	

			var oMessages = [{
				"timestamp": new Date(),
				"deviceID": 123,
				"commandID": sap.ui.getCore().byId("alarmSwitch").getState() ? 1 : 2
			}, {
				"timestamp": new Date(),
				"deviceID": 123,
				"commandID": sap.ui.getCore().byId("photoSwitch").getState() ? 3 : 0
			}, {
				"timestamp": new Date(),
				"deviceID": 123,
				"commandID": sap.ui.getCore().byId("ledSwtich").getState() ? 4 : 5
			}, {
				"timestamp": new Date(),
				"deviceID": 123,
				"commandID": sap.ui.getCore().byId("gpsHoldSwitch").getState() ? 6 : 7
			}, {
				"timestamp": new Date(),
				"deviceID": 123,
				"commandID": sap.ui.getCore().byId("gpsHomeSwitch").getState() ? 8 : 9
			}];

			this.sendRequest(oMessages);
		},

		onPressGPS_HOME: function() {
			var oMessages = [{
				"timestamp": new Date(),
				"deviceID": 123,
				"commandID": sap.ui.getCore().byId("gpsHomeSwitch").getState() ? 8 : 9
			}];
			this.sendRequest(oMessages, true);
		},
		onPressGPS_HOLD: function() {
			var oMessages = [{
				"timestamp": new Date(),
				"deviceID": 123,
				"commandID": sap.ui.getCore().byId("gpsHoldSwitch").getState() ? 6 : 7
			}];
			this.sendRequest(oMessages, true);
		},
		onPressLED: function() {
			var oMessages = [{
				"timestamp": new Date(),
				"deviceID": 123,
				"commandID": sap.ui.getCore().byId("ledSwtich").getState() ? 4 : 5
			}];
			this.sendRequest(oMessages, true);
		},
		onPressPHOTO: function() {
			var oMessages = [{
				"timestamp": new Date(),
				"deviceID": 123,
				"commandID": sap.ui.getCore().byId("photoSwitch").getState() ? 3 : 0
			}];
			this.sendRequest(oMessages, true);
		},
		onPressPHOTOCar: function() {
			var oMessages = [{
				"timestamp": new Date(),
				"deviceID": 123,
				"commandID": 3
			}];
			this.sendRequest(oMessages, true);
		},

		onPressPHOTOCarTog: function() {
			// TO DO INTERVAL NA FOCENI
		},

		onPressALARM: function() {
			var oMessages = [{
				"timestamp": new Date(),
				"deviceID": 123,
				"commandID": sap.ui.getCore().byId("alarmSwitch").getState() ? 1 : 2
			}];
			this.sendRequest(oMessages, true);
		},

		toNoDataPage: function(oEvent) {
			this.getSplitAppObj().to(this.createId("noDataPage"));
		},

		toMainPage: function(oEvent) {
			this.getSplitAppObj().to(this.createId("mainPage"));
		},

		onToMaster: function(oEvent) {
			this.getSplitAppObj().to(this.createId("masterPage"));
		},

		getSplitAppObj: function() {
			var self = this;
			var result = this.byId("splitApp");
			if (!result) {
				jQuery.sap.log.info(self.getResourceBundle().getText("noPageFound"));
			}
			return result;
		},

		sendRequest: function(oMessage, bSingle) {
			this.getModel("mainModel").setProperty("/reqValue", 0);
			var device = sap.ui.getCore().byId("masterSelect").getSelectedItem().getBindingContext().getProperty("IOTDEVICE");
			var method = "http";
			var sender = "IOT APP";
			var messageType = this.getModel("configModel").getProperty("/msgType");
			var iot = new IOT();
			if (bSingle) {
				iot.pushData(device, method, sender, messageType, oMessage);
			} else {
				iot.pushData(device, method, sender, messageType, oMessage, this.reqOk, this.reqFail);
			}

		},

		reqOk: function() {
			var self = window.masterController;
			self.getModel("mainModel").setProperty("/reqValue", 100);
			self.sentToHistory(true);
		},
		reqFail: function() {
			var self = window.masterController;
			self.getModel("mainModel").setProperty("/reqValue", 50);
			self.sentToHistory(false);
		},

		sentToHistory: function(bSend) {
			var device = sap.ui.getCore().byId("masterSelect").getSelectedItem().getBindingContext().getProperty("IOTDEVICE");
			var object = {
				COMMANDID: 1,
				CREATE: new Date(),
				ALARM: sap.ui.getCore().byId("alarmSwitch").getState() ? 1 : 0,
				FOTO: sap.ui.getCore().byId("photoSwitch").getState() ? 1 : 0,
				LED: sap.ui.getCore().byId("ledSwtich").getState() ? 1 : 0,
				GPS_HOLD: sap.ui.getCore().byId("gpsHoldSwitch").getState() ? 1 : 0,
				GPS_HOME: sap.ui.getCore().byId("gpsHomeSwitch").getState() ? 1 : 0,
				STATE: bSend ? 1 : 0,
				G_DEVICE: device
			};

			this.getOwnerComponent().getModel().create("/Req_Data", object, {
				success: function(data, oResponse) {
					console.log("OK");
				},
				error: function(err) {
					this.showError(err);
				}.bind(this)
			});

		},

		onCheckControl: function(oEvent) {
			var oControl = oEvent.getSource();
			oControl.setValueState(oControl.getValue().length > 0 ? "None" : "Error");
			this.checkForm(oControl.getParent());
		},

		checkFormInputs: function(oEvent) {
			return true;
		},

		checkForm: function(oControl) {
			console.log(oControl)
		},

		onHiglightTable: function(oEvent) {
			var items = oEvent.getSource().getItems();
			if (items && items.length > 0) {
				items.forEach(function(item) {
					item.removeStyleClass("ZIOT_TABLE_GREEN");
					item.removeStyleClass("ZIOT_TABLE_RED");
					item.addStyleClass(item.getBindingContext().getProperty("STATE") === 1 ? "ZIOT_TABLE_GREEN" : "ZIOT_TABLE_RED");
				});
			}
		},

		onFilterTable: function(oEvent) {
			if (!this._oSetDialog) {
				this._oSetDialog = sap.ui.xmlfragment("DRONEDRONE_IOT.fragment.settingsDialog", this);
				var oDatePicker = this._oSetDialog.getFilterItems()[0].getCustomControl();
				oDatePicker.setDateValue(new Date());
			}
			jQuery.sap.syncStyleClass("sapUiSizeCompact", this.getView(), this._oSetDialog);
			this.getView().addDependent(this._oSetDialog);

			this._oSetDialog.open();
		},

		confirmFilters: function(oEvent) {
			var device = sap.ui.getCore().byId("masterSelect").getSelectedItem().getBindingContext().getProperty("IOTDEVICE");
			var oDatePicker = this._oSetDialog.getFilterItems()[0].getCustomControl();
			var date = oDatePicker.getDateValue();
			var dateMin = new Date(date.setHours(0, 0, 0, 1));
			var dateMax = new Date(date.setHours(23, 59, 59, 0));
			var oFilter = [new sap.ui.model.Filter("G_DEVICE", "EQ", device), new sap.ui.model.Filter("G_CREATED", "BT", dateMin, dateMax)];
			this.loadLogTable(oFilter);
		},

		resetFilter: function(oEvent) {
			var device = sap.ui.getCore().byId("masterSelect").getSelectedItem().getBindingContext().getProperty("IOTDEVICE");
			var oDatePicker = this._oSetDialog.getFilterItems()[0].getCustomControl();
			oDatePicker.setDateValue(new Date());
			var date = new Date();
			var dateMin = new Date(date.setHours(0, 0, 0, 1));
			var dateMax = new Date(date.setHours(23, 59, 59, 0));
			var oFilter = [new sap.ui.model.Filter("G_DEVICE", "EQ", device), new sap.ui.model.Filter("G_CREATED", "BT", dateMin, dateMax)];
			this.loadLogTable(oFilter);
		},

		showError: function(err) {
			if (err) {
				this.getModel("mainModel").setProperty("/visibleErrBtn", true);
				var oldErr = this.getModel("mainModel").getProperty("/errLogs");
				var msg = {
					description: err.responseText,
					type: "Error",
					message: err.message
				};
				oldErr.push(msg);
				this.getModel("mainModel").setProperty("/countErrBtn", oldErr.length);
			}

		},

		onMessagesButtonPress: function(oEvent) {
			var oMessagesButton = oEvent.getSource();
			if (!this._messagePopover) {
				this._messagePopover = new sap.m.MessagePopover({
					items: {
						path: "mainModel>/errLogs",
						template: new sap.m.MessageItem({
							description: "{mainModel>description}",
							type: "{mainModel>type}",
							title: "{mainModel>message}"
						})
					},
					headerButton: [
						new sap.m.Button({
							icon: "sap-icon://delete",
							type: "Reject",
							press: function() {
								this.getModel("mainModel").setProperty("/errLogs", []);
								this.getModel("mainModel").setProperty("/visibleErrBtn", false);
							}.bind(this)
						})
					]
				});
				oMessagesButton.addDependent(this._messagePopover);
			}
			this._messagePopover.toggle(oMessagesButton);
		}

	});
});